//========================================================================
// RegIncr Ad-Hoc Testing
//========================================================================
`include "vc/trace.v"
`include "regincr/RegIncr.v"

module top (input logic clk, input logic linetrace);

  // Clocking

  

  // Instaniate the design under test

  logic       reset;
  logic [7:0] in_;
  logic [7:0] out;

  // ''' TUTORIAL TASK '''''''''''''''''''''''''''''''''''''''''''''''''''
  // This simulator script is incomplete. As part of the tutorial you
  // will need to instantiate and connect a RegIncr model here.
  // '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''\/

  tut4_verilog_regincr_RegIncr reg_incr
  (
    .clk   (clk),
    .reset (reset),
    .in_   (in_),
    .out   (out)
  );

  // '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''/\

  // Simulate the registered incrementer

  initial begin

    // Dump waveforms

    reset=1;

    // Reset

    #11;
    reset = 1'b0;

    // Cycle 1

    in_ = 8'h01;
    #10;
    
    assert(out == 8'h02 ) $display( " Passed: in = %x, out = %x", in_, out );
    else $error (" Failed: in = %x, out = %x", in_, out);
    // Cycle 2

    in_ = 8'h13;
    #10;
    assert(out == 8'h14 ) $display( " Passed: in = %x, out = %x", in_, out );
    else $error (" Failed: in = %x, out = %x", in_, out);

    // Cycle 3

    in_ = 8'h25;
    #10;
    assert(out == 8'h26 ) $display( " Passed: in = %x, out = %x", in_, out );
    else $error (" Failed: in = %x, out = %x", in_, out);

    // Cycle 4

    in_ = 8'h37;
    #10;
    assert(out == 8'h38 ) $display( " Passed: in = %x, out = %x", in_, out );
    else $error (" Failed: in = %x, out = %x", in_, out);

    $display( " *** PASSED *** ");
    $finish;
  end

endmodule

